#!/usr/bin/python
import serial

# NP 2023

ser = serial.Serial("/dev/ttyAMA0" , baudrate=1200, bytesize=serial.SEVENBITS, parity=serial.PARITY_EVEN, stopbits=serial.STOPBITS_ONE)
print(" Port serie :  " + ser.name)
LF=chr(10)
CR=chr(13)
SP=chr(32)
STX=chr(2)
ETX=chr(3)
infos = ["ADCO", "1ndent1f1ant","OPTARIF","BASE","ISOUSC","45","BASE","000012345","PTEC","TH..","IINST","015","IMAX","090","PAPP","03170","HHPHC","A","MOTDETAT","000000"]

iinst=input('Entrer la valeur du courant instantané en ampère (entre 0 et 90) :')
nbtrame=input('Nombre de trame TIC a envoyer :')

if not(iinst):
	iinst="10"
if not(nbtrame):
	nbtrame=1

for nb in range (3-len(iinst)):
#	
	iinst=("0"+iinst)
infos[11]=(iinst)
#
papp=int(iinst)*230
pappstr=str(papp)
for nb in range (5-len(pappstr)):
	pappstr=("0"+pappstr)
infos[15]=(pappstr)

for azerty in range (int(nbtrame)):
	print ("Début d'envoi de la trame téléinfo N°" + str(azerty))
	ser.write(STX.encode())
	for a in range (0,20,2):

		trame=(infos[a]+SP+infos[a+1])
#		
		somme=0
		somme=sum(ord(ch)for ch in trame)
		somme=(somme&0x3F)+32

		trameenvoi=(LF+trame+SP+chr(somme)+CR)

		ser.write(trameenvoi.encode())
	ser.write(ETX.encode())
	print ("Fin d'envoi de la trame N°" + str(azerty))


ser.flush()

ser.close()
