#!/usr/bin/python

# NP 2023
import spidev
from time import sleep


DEBUG = True
spi_max_speed = 1 * 1000000 # 1 MHz
CE = 0 # CE0 or CE1, bus SPI du peripherique

# configuration SPI
spi = spidev.SpiDev()
spi.open(0,CE)
spi.max_speed_hz = spi_max_speed




def setOutput(val):
    
    lowByte = 0b00000000 
    highByte = ((val)) 
    
    if DEBUG :
        print("Highbyte = {0:8b}".format(highByte))
        print("Lowbyte =  {0:8b}".format(lowByte))
    spi.xfer2([lowByte,highByte])

try:
    while(True):
        ol = input('Entrer un niveau de sortie 0-255 : ')
        outputlevel=int(ol)
        if DEBUG : print ('Valeur binaire : {0:8b} (8 bit)'.format(outputlevel))
        print ("La valeur de sortie devrait etre : {0} ".format(outputlevel * 10000 / 256))
        setOutput(outputlevel)
        sleep(1)

except (KeyboardInterrupt, Exception) as e:
    print(e)
    print ("Fermeture du bus SPI")

    spi.close()

def main():
    pass

if __name__ == '__main__':
    main()
